unit fmUserList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, SvCom_SidCenter, ComCtrls;

type
  TUsersListForm = class(TForm)
    Label1: TLabel;
    EdDomain: TEdit;
    Timer: TTimer;
    SidC: TsvSidCenter;
    LV: TListView;
    Label2: TLabel;
    EdUserName: TEdit;
    Label3: TLabel;
    LbSID: TLabel;
    procedure EdDomainChange(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EdUserNameChange(Sender: TObject);
    procedure LVClick(Sender: TObject);
  private
    { Private declarations }
    _IsBusy: Boolean;
  public
    { Public declarations }
    constructor Create(AComponent: TComponent); override;
  end;

var
  UsersListForm: TUsersListForm;

implementation

{$R *.DFM}

constructor TUsersListForm.Create(AComponent: TComponent); 
begin
    inherited;
end;

procedure TUsersListForm.EdDomainChange(Sender: TObject);
begin
    Timer.Enabled:=True;
end;

procedure TUsersListForm.TimerTimer(Sender: TObject);
var wn : TsvWellKnownSid;
    LI: TListItem;
begin
    if _IsBusy then exit;
    _IsBusy:=True;
    try
        SidC.Domain:=EdDomain.Text;
        SidC.UserName:=EdUserName.Text;
        LbSID.Caption:=SidC.SidString;

        LV.Items.Clear;
        for wn:=Low(TsvWellKnownSid) to High(TsvWellKnownSid) do
        begin
            if wn in [wkCurrentUser,wkOther] then continue;
            SidC.Domain:=EdDomain.Text;
            SidC.WellKnown:=wn;
            if SidC.UserName = '' then continue;
            LI:=LV.Items.Add;
            LI.Caption:=SidC.Domain+'\'+SidC.UserName;
            LI.Data:=SidC.GetSidCopy;
        end;
    finally
        _IsBusy:=False;
        Timer.Enabled:=False;
    end;
end;

procedure TUsersListForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin

    Action:=caFree;
end;

procedure TUsersListForm.EdUserNameChange(Sender: TObject);
begin
    Timer.Enabled:=True;
end;

procedure TUsersListForm.LVClick(Sender: TObject);
begin
    if LV.Selected = nil then exit;
    SidC.SID:=LV.Selected.Data;
    EdDomain.Text:=SidC.Domain;
    EdUserName.Text:=SidC.UserName;
    Timer.Enabled:=False;
    LbSID.Caption:=SidC.SidString;
end;

end.
